#include "mbed.h"
#include "led.h"
#include "serwo.h"
#include "command_decoder.h"



RawSerial pc(USBTX,USBRX,9600);

DigitalOut led_green(LED1);
DigitalOut led_red(LED2);



Timeout LedTimeout;
Ticker Sender;

void LedOff()
{
    led_red=0;
}

int my_puts(char tab[],int size)
{
//retutn 0 if string is valid
    bool StringIsValid=false;
    for( int index=0; index<size; index++) {
        if (tab[index]==NULL) {
            StringIsValid = true;
            break;
        }
    }
    if(StringIsValid == false) {
        LedTimeout.attach(&LedOff, 0.5);
        led_red=1;
        return(1);
    }

    for( int index=0; index<size; index++) {
        if (tab[index]==NULL) {
            pc.putc('\r');
            while(!pc.writeable());
            pc.putc('\n');
            return(0);
        }
        while(!pc.writeable());
        pc.putc(tab[index]);
    }
    return(0);
}

char my_gets(char str[],int size)
{
    if (!pc.readable())return (NULL);
    char c;
    for(int index=0; index <size; index++) {
        c=pc.getc();
        pc.putc(c);
        if ((c=='\r')||(c=='\n')) {
            pc.putc('\r');
            pc.putc('\n');
            str[index]=NULL;
            return (1);
        }
        str[index]=c;
    }
    LedTimeout.attach(&LedOff, 5);
    led_red=1;
    return (1);
}






int main (){

    
    unsigned int uiPreviusPos;
    
    char cOdebranyString[20];
    char init[] = "system start\r\n";
    const char tekstSize = 20;
    my_puts(init,tekstSize);
    
    Servo_Init(100);
     
    while(1){
        
        if (my_gets(cOdebranyString,tekstSize)!=NULL) {
            DecodeMsg( cOdebranyString );
            if ((ucTokenNr > 0) && (asToken[0].eType == KEYWORD)){
                switch (asToken[0].uValue.eKeyword){
                    case CALLIB:
                        Servo_Callib();
                        my_puts("OK",3);
                    break;
                    case GOTO:
                        if (asToken[1].eType == NUMBER){
                            Servo_GoTo(asToken[1].uValue.uiNumber);
                            uiPreviusPos = asToken[1].uValue.uiNumber;
                            my_puts("OK",3);
                        }
                    break;
                    case STEP:
                        if (asToken[1].eType == NUMBER){
                            Servo_GoTo(uiPreviusPos + asToken[1].uValue.uiNumber);
                            uiPreviusPos = uiPreviusPos + asToken[1].uValue.uiNumber;
                            my_puts("OK",3);
                        }
                    break;
                    case ID:
                        my_puts("ID:0x1234",15);
                    break;
                    default:
                    break;
                }
            }
        }
        
    }
}




